<?php

declare(strict_types=1);

namespace Drupal\feature_toggle\Template;

use Drupal\feature_toggle\FeatureStatusInterface;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

/**
 * Twig extension.
 */
final class TwigExtension extends AbstractExtension {

  /**
   * Constructs the extension object.
   */
  public function __construct(
    private readonly FeatureStatusInterface $featureStatus,
  ) {}

  /**
   * {@inheritdoc}
   */
  public function getFunctions(): array {
    $functions[] = new TwigFunction(
      'feature_toggle_status',
      fn (string $argument): bool => $this->featureStatus->getStatus($argument)
    );

    return $functions;
  }

}
